Object.defineProperty(exports, '__esModule', { value: true });

var polaris = require('@shopify/polaris');
var polarisIcons = require('@shopify/polaris-icons');
var ReactTooltip = require('react-tooltip');
var Link = require('next/link');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var ReactTooltip__default = /*#__PURE__*/_interopDefaultLegacy(ReactTooltip);
var Link__default = /*#__PURE__*/_interopDefaultLegacy(Link);

var Trigger = function Trigger(_ref) {
  var dataFor = _ref.dataFor,
      _ref$showOnlyIcon = _ref.showOnlyIcon,
      showOnlyIcon = _ref$showOnlyIcon === void 0 ? false : _ref$showOnlyIcon;
  return React.createElement("div", {
    "data-for": dataFor,
    "data-tip": true
  }, showOnlyIcon ? React.createElement(polaris.Icon, {
    source: polarisIcons.QuestionMarkMajor,
    color: "base"
  }) : React.createElement(polaris.Button, {
    icon: polarisIcons.QuestionMarkMajor
  }));
};

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

var Button = function Button(_ref) {
  var text = _ref.text,
      url = _ref.url,
      showSaveBar = _ref.showSaveBar,
      onHandleMenuNav = _ref.onHandleMenuNav;
  if (showSaveBar) {
    return React.createElement(polaris.Button, {
      primary: true,
      onClick: function onClick() {
        return onHandleMenuNav(url);
      }
    }, text);
  } else {
    return React.createElement(Link__default['default'], {
      href: {
        pathname: url
      }
    }, React.createElement("a", {
      style: {
        textDecoration: 'none'
      }
    }, React.createElement(polaris.Button, {
      primary: true
    }, text)));
  }
};

var Content = function Content(_ref) {
  var isAvailable = _ref.isAvailable,
      desc = _ref.desc,
      title = _ref.title,
      showSaveBar = _ref.showSaveBar,
      onHandleMenuNav = _ref.onHandleMenuNav,
      btn = _ref.btn,
      children = _ref.children;
  return React.createElement(React.Fragment, null, React.createElement(polaris.TextContainer, {
    spacing: "loose"
  }, React.createElement(polaris.Heading, null, title), desc.map(function (textLine, index) {
    return textLine && typeof textLine === 'string' ? React.createElement("p", {
      className: "tooltipText",
      key: textLine + index
    }, textLine) : null;
  })),
  children && children(),
  !isAvailable ? React.createElement(React.Fragment, null, React.createElement("br", null), React.createElement(Button, {
    text: btn.text,
    url: btn.url,
    showSaveBar: showSaveBar,
    onHandleMenuNav: onHandleMenuNav
  })) : null);
};

var e=[],t=[];function n(n,r){if(n&&"undefined"!=typeof document){var a,s=!0===r.prepend?"prepend":"append",d=!0===r.singleTag,i="string"==typeof r.container?document.querySelector(r.container):document.getElementsByTagName("head")[0];if(d){var u=e.indexOf(i);-1===u&&(u=e.push(i)-1,t[u]={}),a=t[u]&&t[u][s]?t[u][s]:t[u][s]=c();}else a=c();65279===n.charCodeAt(0)&&(n=n.substring(1)),a.styleSheet?a.styleSheet.cssText+=n:a.appendChild(document.createTextNode(n));}function c(){var e=document.createElement("style");if(e.setAttribute("type","text/css"),r.attributes)for(var t=Object.keys(r.attributes),n=0;n<t.length;n++)e.setAttribute(t[n],r.attributes[t[n]]);var a="prepend"===s?"afterbegin":"beforeend";return i.insertAdjacentElement(a,e),e}}

var css = ".tooltipHoverable {\r\n    max-width: 700px;\r\n    pointer-events: auto !important;\r\n    opacity: 1 !important;\r\n}\r\n\r\n.tooltipHoverable:hover {\r\n    visibility: visible !important;\r\n    opacity: 1 !important;\r\n}\r\n\r\n.tooltipHoverable p.tooltipText {\r\n    font-size: 1.5rem;\r\n}";
n(css,{});

var settings = {
  "default": {
    className: 'tooltipHoverable Polaris-Tooltip-TooltipOverlay',
    effect: 'solid',
    delayHide: 100,
    backgroundColor: '#fff',
    textColor: '#212b36',
    arrowColor: '#ccc'
  }
};
settings.rightPlace = _objectSpread2({}, settings["default"]);
var Popups = function Popups(_ref) {
  var tooltips = _ref.tooltips,
      btn = _ref.btn,
      showSaveBar = _ref.showSaveBar,
      innerWidth = _ref.innerWidth,
      onHandleMenuNav = _ref.onHandleMenuNav;
  if (innerWidth < 1200 && innerWidth > 768) {
    settings.rightPlace = {
      place: "right"
    };
  }
  return React.createElement(React.Fragment, null, tooltips.map(function (item) {
    return React.createElement(ReactTooltip__default['default'], _extends({
      key: item.dataFor,
      id: item.dataFor
    }, settings[item.setting]), React.createElement(Content, {
      isAvailable: item.available,
      desc: item.desc,
      title: item.title,
      showSaveBar: showSaveBar,
      onHandleMenuNav: onHandleMenuNav,
      btn: btn,
      children: item.children
    }));
  }));
};

exports.TooltipPopup = Popups;
exports.TooltipTrigger = Trigger;
